var version     = '3.2.0';

const localePacks  = {"en-US":    true,
                       "de-AT":    true  // all possible languages for installation
                      };

const displayName = 'Preferences Toolbar';
const appName     = 'prefbar';
const author      = 'Manuel Reimer';

const jarName     = appName + '.jar';

var installedFiles   = [];
var localesToInstall = [];
var SetupLocaleDB    = null;

function DoLanguageStuff()
{
	var languageAttrib = decodeURIComponent(Install.arguments);
	var SetupLocale = "";
	if (languageAttrib in localePacks)
	{
		localesToInstall.push(languageAttrib);
		SetupLocale = languageAttrib;
	}
	else
	{
		for (s in localePacks)
		      localesToInstall.push(s);
		SetupLocale = "en-US";	
	}
	SetupLocaleDB = loadResources(SetupLocale);
}

function InstallAddon()
{
	var err = initInstall(displayName, appName, version);
	if (err != SUCCESS) return SOURCE_DOES_NOT_EXIST;

	DoLanguageStuff();

	var UChrome	= getFolder('Chrome');
	var contentFlag = CONTENT | DELAYED_CHROME;
	var localeFlag  = LOCALE | DELAYED_CHROME;

	var existsInGlobal  = File.exists(getFolder(UChrome, jarName));
	var existsInProfile = File.exists(getFolder(getFolder('Current User', 'chrome'), jarName));
	if (existsInGlobal && existsInProfile) return ALREADY_EXISTS;

	if (existsInProfile ||
		(!existsInGlobal && confirm(SetupLocaleDB.installToChrome))) {
		UChrome = getFolder('Current User', 'chrome');
		contentFlag = CONTENT | PROFILE_CHROME;
		localeFlag  = LOCALE | PROFILE_CHROME;
	}


	logComment('initInstall: ' + err);
	setPackageFolder(UChrome);

	addFile(displayName, 'chrome/' + jarName, UChrome, '');
	var folder = getFolder(UChrome, jarName);
	installedFiles.push(folder);

	// Content
	registerChrome(contentFlag, folder, 'content/'+appName+'/');

	// Language packs
	for (s in localesToInstall)
		registerChrome(localeFlag, folder, 'locale/' + localesToInstall[s] + '/'+appName+'/');


	err = getLastError();
	if (err != SUCCESS)
	{
		alert(SetupLocaleDB.installfailed);
		return err;
	}

	err = performInstall();
	if (err != SUCCESS && err != REBOOT_NEEDED)
	{
		alert(SetupLocaleDB.installfailed);
		return err;
	}

	alert('Ver.'+version+'\n\n'+ SetupLocaleDB.installed + '\n' + installedFiles.join('\n') + '\n\n\n' + SetupLocaleDB.complete);
	return SUCCESS;
}

// Start this install script
var status = InstallAddon();
if (status != SUCCESS) cancelInstall(status);
